/*---------------------------------------------------------------------------/
/  FatFs - FAŢ ђPʕ  R0.11a                    (C)ChaN, 2015        /
/-----------------------------------------------------------------------------/
/ FatFsPʕ͈ȉ̏̋jŊJ閳̿ĳłB
/
/ 쌠 (C) 2015, ChaN, s
/
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
/
/ ̿ĳ͒쌠ێ҂ƍv҂ɂ"󂻂̂܂"Œ񋟂A̿ĳ
/ Ɋ֘Aǂȕۏ؂Ɛӂ܂B
/ 쌠L҂܂͍v҂͂̿ĳ̎gpɂĔǂȏQɑ΂
/ ӔC𕉂܂B
/---------------------------------------------------------------------------*/

#ifndef _FATFS
#define _FATFS	64180	/* ID */

#ifdef __cplusplus
extern "C" {
#endif

#include "integer.h"	/* {` */
#include "ffconf.h"		/* FatFs`ԐݒCӑI */
#if _FATFS != _FFCONF
#error Wrong configuration file (ffconf.h).
#endif

/* حъǗ̒` */

#if _MULTI_PARTITION		/* ߰è݌`Ԑݒ */
typedef struct {
	BYTE pd;	/* ײޔԍ */
	BYTE pt;	/* ߰è: 0:o, 1`4:߰è) */
} PARTITION;
extern PARTITION VolToPart[];	/* ح - ߰èݕ\\ */
#define LD2PD(vol) (VolToPart[vol].pd)	/* ײޔԍ擾 */
#define LD2PT(vol) (VolToPart[vol].pt)	/* ߰èݎwW擾 */

#else							/* P߰è݌`Ԑݒ */
#define LD2PD(vol) (BYTE)(vol)	/* e_ײނ͓ײޔԍŊ */
#define LD2PT(vol) 0			/* SFDōŏ̗L߰è݂{ */

#endif


/* FatFs APIł߽̌` */

#if _LFN_UNICODE			/* Unicode */
#if !_USE_LFN
#error _LFN_UNICODE must be 0 at non-LFN cfg.
#endif
#ifndef _INC_TCHAR
typedef WCHAR TCHAR;
#define _T(x) L ## x
#define _TEXT(x) L ## x
#endif

#else						/* ANSI/OEM */
#ifndef _INC_TCHAR
typedef char TCHAR;
#define _T(x) x
#define _TEXT(x) x
#endif

#endif


/* ̧ ёΏە\(FATFS) */

typedef struct {
	BYTE	fs_type;		/* FAT⏕`(0:t) */
	BYTE	drv;			/* ײޔԍ */
	BYTE	csize;			/* ׽̾(1,2,4`128) */
	BYTE	n_fats;			/* FAT(1܂2) */
	BYTE	wflag;			/* win[]׸(b0:ω) */
	BYTE	fsi_flag;		/* FSINFO׸(b7:֎~, b0:ω) */
	WORD	id;				/* ̧ юtID */
	WORD	n_rootdir;		/* {ިڸؓ(FAT12/16) */
#if _MAX_SS != _MIN_SS
	WORD	ssize;			/* ޲Đ(512,1024,2048܂4096) */
#endif
#if _FS_REENTRANT
	_SYNC_t	sobj;			/* Ώە̎ʎq
#endif
#if !_FS_READONLY
	DWORD	last_clust;		/* 蓖ĂꂽŏI׽ */
	DWORD	free_clust;		/* 󂫸׽ */
#endif
#if _FS_RPATH
	DWORD	cdir;			/* ݂ިڸ؂̊Jn׽(0:{) */
#endif
	DWORD	n_fatent;		/* FAT(=׽+2) */
	DWORD	fsize;			/* FAT̾ */
	DWORD	volbase;		/* حъJn */
	DWORD	fatbase;		/* FATJn */
	DWORD	dirbase;		/* {ިڸ؊Jn(FAT32:׽ԍ) */
	DWORD	database;		/* ްJn */
	DWORD	winsect;		/* win[]Ō錻݂̾ */
	BYTE	win[_MAX_SS];	/* ިڸ,FAT(tiny`Ԑݒł̧ ް)pި  */
} FATFS;


/* ّ̧Ώە\(FIL) */

typedef struct {
	FATFS*	fs;				/* ֘A̧ ёΏەւ̈ʒuwq(**ԕύX֎~**) */
	WORD	id;				/* Ļ юtID(**ԕύX֎~**) */
	BYTE	flag;			/* ׸ */
	BYTE	err;			/* ~׸(ُ필) */
	DWORD	fptr;			/* ̧ٓǂݏʒuwq(̧قJ0) */
	DWORD	fsize;			/* ̧ٗe */
	DWORD	sclust;			/* ̧يJn׽(0:׽AȂ, fsize=0A0) */
	DWORD	clust;			/* fpteř̸݂׽(fprt=0ɖ) */
	DWORD	dsect;			/* buf[]Ō龸ԍ(0:) */
#if !_FS_READONLY
	DWORD	dir_sect;		/* ިڸؓ܂޾ԍ */
	BYTE*	dir_ptr;		/* win[]ިڸؓւ̈ʒuwq */
#endif
#if _USE_FASTSEEK
	DWORD*	cltbl;			/* ׽ڑ蓖ĕ\ւ̈ʒuwq(̧قJNULL) */
#endif
#if _FS_LOCK
	UINT	lockid;			/* 1َ̧{ID{(Files[]̧ ̫\̎wW) */
#endif
#if !_FS_TINY
	BYTE	buf[_MAX_SS];	/* َ̧Iްǂݏ */
#endif
} FIL;


/* ިڸؑΏە\(DIR) */

typedef struct {
	FATFS*	fs;				/* Ļ ёΏەւ̈ʒuwq(**ԕύX֎~**) */
	WORD	id;				/* Ļ юtID(**ԕύX֎~**) */
	WORD	index;			/* ݂̓ǂݏwWԍ */
	DWORD	sclust;			/* \Jn׽(0:{ިڸ) */
	DWORD	clust;			/* ̸݂׽ */
	DWORD	sect;			/* ݂̾ */
	BYTE*	dir;			/* win[]݂̌SFNւ̈ʒuwq */
	BYTE*	fn;				/* SFN(o)ւ̈ʒuwq{̧ٖ[8],gq[3],[1]} */
#if _FS_LOCK
	UINT	lockid;			/* َ̧{ID(Files[]̧ ̫\̎wW) */
#endif
#if _USE_LFN
	WCHAR*	lfn;			/* LFNƊɏՕւ̈ʒuwq */
	WORD	lfn_idx;		/* ŌɈvLFNwWԍ(0xFFFF:LFNȂ) */
#endif
#if _USE_FIND
	const TCHAR*	pat;	/* Ovlւ̈ʒuwq */
#endif
} DIR;


/* ُ̧\(FILINFO) */

typedef struct {
	DWORD	fsize;			/* ̧ٗe */
	WORD	fdate;			/* ŏIύXt */
	WORD	ftime;			/* ŏIύX */
	BYTE	fattrib;		/*  */
	TCHAR	fname[13];		/* Z̧ٖ(8.3`) */
#if _USE_LFN
	TCHAR*	lfname;			/* LFNɏՕւ̈ʒuwq */
	UINT 	lfsize;			/* TCHARłLFNɏՕe */
#endif
} FILINFO;


/* ̧ي֐Ԃ(FRESULT) */

typedef enum {
	FR_OK = 0,				/* (0)  */
	FR_DISK_ERR,			/* (1) ިo͑wʰ޳ُ픭 */
	FR_INT_ERR,				/* (2) \ᔽ */
	FR_NOT_READY,			/* (3) ײޕs */
	FR_NO_FILE,				/* (4) ̧قtȂ */
	FR_NO_PATH,				/* (5) ߽tȂ */
	FR_INVALID_NAME,		/* (6) ߽` */
	FR_DENIED,				/* (7) ֎~܂ިڸؖt̂߂ɱ */
	FR_EXIST,				/* (8) ֎~̂߂ɱ */
	FR_INVALID_OBJECT,		/* (9) ̧/ިڸؑΏ */
	FR_WRITE_PROTECTED,		/* (10) ײނݕی */
	FR_INVALID_DRIVE,		/* (11) _ײޔԍ */
	FR_NOT_ENABLED,			/* (12) حтƗ̈Ȃ */
	FR_NO_FILESYSTEM,		/* (13) LFAT޲حтȂ */
	FR_MKFS_ABORTED,		/* (14) ǂꂩҰُ̂߂f_mkfs()~ */
	FR_TIMEOUT,				/* (15) `ꂽԓłح ̏Ȃ */
	FR_LOCKED,				/* (16) 삪ً̧Ljɏ]ċp */
	FR_NOT_ENOUGH_CORE,		/* (17) LFNƊɏՕ蓖ĕs\ */
	FR_TOO_MANY_OPEN_FILES,	/* (18) Jِ̧>_FS_LOCK */
	FR_INVALID_PARAMETER	/* (19) ^ꂽҰ */
} FRESULT;


/*--------------------------------------------------------------*/
/* FatFsPʕp̪                                      */

FRESULT f_open (FIL* fp, const TCHAR* path, BYTE mode);				/* ̧قJ܂͍쐬 */
FRESULT f_close (FIL* fp);											/* Jّ̧Ώە */
FRESULT f_read (FIL* fp, void* buff, UINT btr, UINT* br);			/* ̧قްǂ */
FRESULT f_write (FIL* fp, const void* buff, UINT btw, UINT* bw);	/* ̧قް */
FRESULT f_forward (FIL* fp, UINT(*func)(const BYTE*,UINT), UINT btf, UINT* bf);	/* ް] */
FRESULT f_lseek (FIL* fp, DWORD ofs);								/* ّ̧Ώە̈ʒuwqړ */
FRESULT f_truncate (FIL* fp);										/* ِ̧؂l */
FRESULT f_sync (FIL* fp);											/* ̧ق̷ꂽްo */
FRESULT f_opendir (DIR* dp, const TCHAR* path);						/* ިڸ؂J */
FRESULT f_closedir (DIR* dp);										/* Jިڸ؂ */
FRESULT f_readdir (DIR* dp, FILINFO* fno);							/* ިڸ؍ڂǂ */
FRESULT f_findfirst (DIR* dp, FILINFO* fno, const TCHAR* path, const TCHAR* pattern);	/* ŏ̧ق{ */
FRESULT f_findnext (DIR* dp, FILINFO* fno);							/* ̧ق{ */
FRESULT f_mkdir (const TCHAR* path);								/* ިڸ؍쐬 */
FRESULT f_unlink (const TCHAR* path);								/* ̧ق܂ިڸ؂폜 */
FRESULT f_rename (const TCHAR* path_old, const TCHAR* path_new);	/* ̧ق܂ިڸ؂/ړ */
FRESULT f_stat (const TCHAR* path, FILINFO* fno);					/* ُ̧Ԏ擾 */
FRESULT f_chmod (const TCHAR* path, BYTE attr, BYTE mask);			/* ̧/ިڸ؂̑ύX */
FRESULT f_utime (const TCHAR* path, const FILINFO* fno);			/* ̧/ިڸ؂̎ύX */
FRESULT f_chdir (const TCHAR* path);								/* ݂ިڸؕύX */
FRESULT f_chdrive (const TCHAR* path);								/* ݂ײޕύX */
FRESULT f_getcwd (TCHAR* buff, UINT len);							/* ݂ިڸ؂擾 */
FRESULT f_getfree (const TCHAR* path, DWORD* nclst, FATFS** fatfs);	/* ײޏ̋󂫸׽擾 */
FRESULT f_getlabel (const TCHAR* path, TCHAR* label, DWORD* vsn);	/* ح َ擾 */
FRESULT f_setlabel (const TCHAR* label);							/* ح ِݒ */
FRESULT f_mount (FATFS* fs, const TCHAR* path, BYTE opt);			/* _ײނ̎t/O */
FRESULT f_mkfs (const TCHAR* path, BYTE sfd, UINT au);				/* حя̧ т쐬 */
FRESULT f_fdisk (BYTE pdrv, const DWORD szt[], void* work);			/* ײނ߰è݂ɕ */
int f_putc (TCHAR c, FIL* fp);										/* ̧قɕzu */
int f_puts (const TCHAR* str, FIL* cp);								/* ̧قɕzu */
int f_printf (FIL* fp, const TCHAR* str, ...);						/* ̧قɌ`ꂽzu */
TCHAR* f_gets (TCHAR* buff, int len, FIL* fp);						/* ̧ق當擾 */

#define f_eof(fp) ((int)((fp)->fptr == (fp)->fsize))
#define f_error(fp) ((fp)->err)
#define f_tell(fp) ((fp)->fptr)
#define f_size(fp) ((fp)->fsize)
#define f_rewind(fp) f_lseek((fp), 0)
#define f_rewinddir(dp) f_readdir((dp), 0)

#ifndef EOF
#define EOF (-1)
#endif


/*--------------------------------------------------------------*/
/* ǉgpҒ`֐                                           */

/* RTC֐ */
#if !_FS_READONLY && !_FS_NORTC
DWORD get_fattime (void);
#endif

/* Unicodex֐ */
#if _USE_LFN							/* Unicode-OEMϊ */
WCHAR ff_convert (WCHAR chr, UINT dir);	/* OEM-Unicodeoϊ */
WCHAR ff_wtoupper (WCHAR chr);			/* Unicode啶ϊ */
#if _USE_LFN == 3						/* ؊֐ */
void* ff_memalloc (UINT msize);			/* ؉򊄂蓖 */
void ff_memfree (void* mblock);			/* ؉ */
#endif
#endif

/* ֐ */
#if _FS_REENTRANT
int ff_cre_syncobj (BYTE vol, _SYNC_t* sobj);	/* Ώە쐬 */
int ff_req_grant (_SYNC_t sobj);				/* Ώە{ */
void ff_rel_grant (_SYNC_t sobj);				/* Ώە */
int ff_del_syncobj (_SYNC_t sobj);				/* Ώە폜 */
#endif


/*--------------------------------------------------------------*/
/* ׸ނƕψʱڽ                                              */

/* ̧ ُ̧׸(FIL.flag) */

#define	FA_READ				0x01
#define	FA_OPEN_EXISTING	0x00

#if !_FS_READONLY
#define	FA_WRITE			0x02
#define	FA_CREATE_NEW		0x04
#define	FA_CREATE_ALWAYS	0x08
#define	FA_OPEN_ALWAYS		0x10
#define FA__WRITTEN			0x20
#define FA__DIRTY			0x40
#endif

/* FAT⏕`(FATFS.fs_type) */

#define FS_FAT12	1
#define FS_FAT16	2
#define FS_FAT32	3

/* ިڸؓpّ̧ޯ */

#define	AM_RDO	0x01	/* ǂݍݐp */
#define	AM_HID	0x02	/* B */
#define	AM_SYS	0x04	/*  */
#define	AM_VOL	0x08	/* ح  */
#define AM_LFN	0x0F	/* LFN */
#define AM_DIR	0x10	/* ިڸ */
#define AM_ARC	0x20	/*  */
#define AM_MASK	0x3F	/* `ޯĂ̎Օ */

/* @\ */

#define CREATE_LINKMAP	0xFFFFFFFF


/*--------------------------------*/
/* ޲Č걸ϸ              */

#if _WORD_ACCESS == 1	/* FAT\̂Ɍ걸 */
#define	LD_WORD(ptr)		(WORD)(*(WORD*)(BYTE*)(ptr))
#define	LD_DWORD(ptr)		(DWORD)(*(DWORD*)(BYTE*)(ptr))
#define	ST_WORD(ptr,val)	*(WORD*)(BYTE*)(ptr)=(WORD)(val)
#define	ST_DWORD(ptr,val)	*(DWORD*)(BYTE*)(ptr)=(DWORD)(val)
#else					/* FAT\̂޲ĒPʱgp */
#define	LD_WORD(ptr)		(WORD)(((WORD)*((BYTE*)(ptr)+1)<<8)|(WORD)*(BYTE*)(ptr))
#define	LD_DWORD(ptr)		(DWORD)(((DWORD)*((BYTE*)(ptr)+3)<<24)|((DWORD)*((BYTE*)(ptr)+2)<<16)|((WORD)*((BYTE*)(ptr)+1)<<8)|*(BYTE*)(ptr))
#define	ST_WORD(ptr,val)	*(BYTE*)(ptr)=(BYTE)(val); *((BYTE*)(ptr)+1)=(BYTE)((WORD)(val)>>8)
#define	ST_DWORD(ptr,val)	*(BYTE*)(ptr)=(BYTE)(val); *((BYTE*)(ptr)+1)=(BYTE)((WORD)(val)>>8); *((BYTE*)(ptr)+2)=(BYTE)((DWORD)(val)>>16); *((BYTE*)(ptr)+3)=(BYTE)((DWORD)(val)>>24)
#endif

#ifdef __cplusplus
}
#endif

#endif /* _FATFS */
