/**
 * \file
 *
 * \brief main ̧
 *
 * 쌠 (c) 2016 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */

/* == ݸٰ ̧ ========================================================== */

#include <avr/io.h>
#include <stdio.h>
#include <avr/pgmspace.h>
#include <string.h>
#include "gfx_mono.h"
#include "sysfont.h"
#include "uart.h"
#include "ff.h"
#include "diskio.h"

static FILE usr_stdout = FDEV_SETUP_STREAM(uart_putc, NULL, _FDEV_SETUP_WRITE);

FRESULT f_res;
FATFS fs;
FIL file_object;
char test_file_name[] = "0:test.txt";

UINT bytes_written;

# define ADDRESS	0x4F					// ]uڽ

volatile int16_t temperature;
volatile float temperature_final;
char BUFF[40];
volatile bool log_data = false;

// ̊֐TWI̪܂B

void temp_sensor_init (void)
{
	TWBR1 = 32;												// 100kHzSCL`Ԑݒ
	TWCR1 = (1 << TWEN1) | (1 << TWINT1) | (1 << TWEA1);
	TWCR1 = (1 << TWEN1) | (1 << TWINT1) | (1 << TWSTA1);	// Jno
	while(!(TWCR1 & (1<<TWINT1)));		/* TWINT׸ސݒ܂őҋ@B͊JnoꂽƂ\܂B */
	TWDR1 = (ADDRESS << 1)| 0;			// ]uڽ+ݐݒ
	TWCR1 = (1<<TWINT1) | (1<<TWEN1);	// ]uڽ+ݑoJn
	while(!(TWCR1 & (1<<TWINT1)));		// ]uڽ+ݑoҋ@
	TWDR1 = 0;							// ]ủxڼ޽ւ̈ʒuwq(=0)ݒ
	TWCR1 = (1<<TWINT1) | (1<<TWEN1);	// ]ủxڼ޽ւ̈ʒuwqoJn
	while(!(TWCR1 & (1<<TWINT1)));		// ]ủxڼ޽ւ̈ʒuwqoҋ@
	TWCR1 = (1<<TWINT1)|(1<<TWEN1)|(1<<TWSTO1);		// ~o
}

int16_t temp_sensor_read (void)
{
	static uint16_t temp = 0;
	static int16_t temp_int = 0;

	TWCR1 = (1 << TWEN1) | (1 << TWINT1) | (1 << TWSTA1);	// Jno
	while(!(TWCR1 & (1<<TWINT1)));		/* TWINT׸ސݒ܂őҋ@B͊JnoꂽƂ\܂B */
	
	/* Load slave address into TWDR Register and enable Read. 
	Clear TWINT bit in TWCR to start transmission of address.*/
	TWDR1 = (ADDRESS << 1)| 1;			// ]uڽ+ǂݍݐݒ
	TWCR1 = (1<<TWINT1) | (1<<TWEN1);	// ]uڽ+ǂݍݑoJn
	while(!(TWCR1 & (1<<TWINT1)));		// ]uڽ+ǂݍݑoҋ@
	TWCR1 = (1<<TWINT1) | (1<<TWEN1)|(1<<TWEA1);	// ACKw
	while(!(TWCR1 & (1<<TWINT1)));		// ޲ĎMҋ@
	temp = (TWDR1 << 8);				// Mް޲Ă擾/ۑ
	TWCR1 = (1<<TWINT1) | (1<<TWEN1);	// NACKw
	while(!(TWCR1 & (1<<TWINT1)));		// ޲ĎMҋ@
	temp |= TWDR1;						// Mް޲Ă擾/ۑ
	TWCR1 = (1<<TWINT1)|(1<<TWEN1)|(1<<TWSTO1);		// ~o
	temp_int = (int16_t)temp;			// ް͉7ޯĂ09ޯē̂ޯĈʒu␳
	temp_int = temp_int >> 7;
	return (temp_int);
}

int main (void)
{
	uart_init(51);
	stdout = &usr_stdout;

	DDRB |= (1 << DDRB3);				// LED1(PB3)o͂ƂČ`Ԑݒ
	PORTB |= (1 << PORTB3);
	DDRB &= ~(1 << DDRB2);				// BUTTON1(PB2)ٱߕt͂ƂČ`Ԑݒ
	PORTB |= (1 << PORTB2);
	gfx_mono_init();					// ̨ ײ؏
	temp_sensor_init();					// TWI̪
	f_res = f_mount(&fs, "0:", 1);		// ̧ я
	test_file_name[0] = 0 + '0';

	while (1)
	{
		if (!(PINB & (1 << PINB2)))		// BUTTON1ꂽ
		{								// BUTTON1ŁA
			_delay_ms(10);				// L𒲂ׂ邽߂ɒ񋟂x
			if (!(PINB & (1 << PINB2)))	// BUTTON1ŁA
			{
				while (!(PINB & (1 << PINB2)));		// BUTTON1ҋ@
				log_data = !log_data;	// ON/OFF׸ޔ]
			}
		}
		temperature = temp_sensor_read();				// xl擾
		temperature_final = (float)temperature * 0.5;	// 9ޯ ް8ޯĂɊۂ(=~0.5)
		sprintf(BUFF,"Temp is %f C\n\r",temperature_final);		// zɕli[
		gfx_mono_draw_string(BUFF,0,0,&sysfont);
		if (log_data)					// ONŁA
		{
			PORTB &= ~(1 << PORTB3);					// LED1_
			gfx_mono_draw_string("Logging Data..",0,20,&sysfont);
			f_res = f_open(&file_object, (char const *)test_file_name, FA_OPEN_ALWAYS | FA_WRITE);
			f_res = f_lseek(&file_object, f_size(&file_object));
			f_res = f_write(&file_object, BUFF, sizeof(BUFF), &bytes_written);
			f_res = f_close(&file_object);
		}
		else							// OFFŁA
		{
			PORTB |= (1 << PORTB3);					// LED1
			gfx_mono_draw_string("              ",0,20,&sysfont);
		}
		_delay_ms(100);
	}
}
